<template>
  <div class="order-step">
    <div class="order-step__route">
      <div class="order-step__route-header">
        <h2 :class="{ active: isRouteValid }" class="order-step-title">
          Маршрут
          <i class="icon checked" />
        </h2>
        <div
          class="order-step__route-info"
          v-if="logchain && logchain.routeDuration > 0"
        >
          <span>
            {{ getLength(logchain.routeLength) + " км" || "0 км" }} ≈
            {{ getDuration(logchain.routeDuration) || "0 дней" }} в движении
          </span>
          <i class="icon map" />
          Посмотреть на карте
        </div>
      </div>
      <div class="order-route">
        <div class="order-route__row">
          <div class="order-route__location-input-path">
            <i class="icon route-loading -diamond-orange-yellow" />
            <b> Погрузка</b>
          </div>
          <div class="order-route__row-content">
            <div class="order-route__location">
              <div class="order-route__location-input">
                <ObAddressInput
                  title="Адрес"
                  :address="addressFrom.label"
                  :isValid="firstStepErrors.address.valid"
                  :popoverMessage="firstStepErrors.address.errorTooltip"
                  :prefixIcon="addressFrom.icon || ''"
                  :locationsTypes="locationsTypes"
                  placeholder="Например, Мосфильмовская ул., 17, Москва, Россия, 119590"
                  required
                  mapId="map-2"
                  :showMap="false"
                  customIcon="map"
                  customAction
                  isRadius
                  data-qa="addressFrom"
                  @input="setAddressFrom"
                  @on-change-address="setAddressFrom"
                  @customAction="onOpenMapModal(addressFrom, 'from')"
                />
                <div class="order-route__base" v-if="addressFrom.locationTitle">
                  Относится к опорному пункту:
                  <span>{{ addressFrom.locationTitle }}</span>
                </div>
              </div>
            </div>
            <div class="order-route__date">
              <order-date-picker
                v-if="dateAndType.type === 'departure'"
                v-model="dateAndType.date"
                :blockDaysBeforeToday="true"
                blockBefore
                :label="dateAndTypeLable"
                :isTime="true"
                :timeInterval="15"
                :blockTimeBefore="`${(new Date()).getHours()}:${(new Date()).getMinutes() + 30}`"
                :isValidDate="firstStepErrors.date.valid"
                :dateValidationMessage="firstStepErrors.date.errorTooltip"
                :routeType="dateAndType.type"
                :allowWeekends="true"
                data-qa="dateFrom"
                @input="dateAndTypeChanged"
                @close="onDatepickerClose"
              >
                <div style="display:flex; justify-content: space-around">
                  <ob-radio
                    label="Погрузка"
                    valueInput="departure"
                    v-model="type"
                    data-qa="loadingFrom"
                  />
                  <ob-radio
                    label="Отгрузка"
                    valueInput="arrive"
                    v-model="type"
                    data-qa="unloadingFrom"
                  />
                </div>
              </order-date-picker>
            </div>
          </div>
        </div>
        <div
          class="order-route__row order-route__row--additional"
          v-if="loadingPoints.length"
        >
          <div
            class="order-route__point"
            v-for="point in loadingPoints"
            :key="point.uuid"
          >
            <div class="order-route__location-input">
              <div class="order-route__location-input-path">
                <i class="icon route-loading -diamond-orange-yellow" />
                <b> Погрузка</b>
                <i class="icon close" @click="onRemoveFromPoint(point)"></i>
              </div>
              <ObAddressInput
                title="Адрес"
                :address="point.label"
                :isValid="firstStepErrors.address.valid"
                :popoverMessage="firstStepErrors.address.errorTooltip"
                :prefixIcon="point.icon || ''"
                :locationsTypes="locationsTypes"
                placeholder="Например, Мосфильмовская ул., 17, Москва, Россия, 119590"
                required
                :mapId="`map-${point.uuid}`"
                :showMap="false"
                customIcon="map"
                customAction
                isRadius
                data-qa="addressFrom"
                @input="setadditionalLoading($event, point)"
                @on-change-address="setadditionalLoading($event, point)"
                @customAction="onOpenMapModal(point, 'from', point)"
              />
              <div class="order-route__base" v-if="point.locationTitle">
                Относится к опорному пункту:
                <span>{{ point.locationTitle }}</span>
              </div>
            </div>
          </div>
        </div>
        <div class="order-route__add">
          <i class="icon plus" />
          <span @click="addLoadingPoint"> Добавить погрузку</span>
        </div>
        <div class="order-route__row">
          <div class="order-route__location-input-path">
            <i class="icon route-unloading -green-700" />
            <b> Разгрузка</b>
          </div>
          <div class="order-route__row-content">
            <div class="order-route__location">
              <div class="order-route__location-input">
                <ObAddressInput
                  title="Адрес"
                  :address="addressTo.label"
                  :isValid="firstStepErrors.address.valid"
                  :popoverMessage="firstStepErrors.address.errorTooltip"
                  :prefixIcon="addressTo.icon || ''"
                  :locationsTypes="locationsTypes"
                  placeholder="Например, Невский пр., 1, Санкт-Петербург, Россия"
                  required
                  data-qa="addressTo"
                  @input="setAddressTo"
                  mapId="map-3"
                  :showMap="false"
                  customIcon="map"
                  customAction
                  @on-change-address="setAddressTo"
                  @customAction="onOpenMapModal(addressTo, 'to')"
                />
                <div class="order-route__base" v-if="addressTo.locationTitle">
                  Относится к опорному пункту:
                  <span>{{ addressTo.locationTitle }}</span>
                </div>
              </div>
            </div>
            <div class="order-route__date">
              <order-date-picker
                v-if="dateAndType.type === 'arrive'"
                v-model="dateAndType.date"
                :blockDaysBeforeToday="true"
                :sinceTo="[
                  {
                    from: new Date(1976, 0, 0),
                    to: new Date().setDate(new Date().getDate() + 7),
                  },
                ]"
                :label="dateAndTypeLable"
                :isTime="true"
                :timeInterval="15"
                :isValidDate="firstStepErrors.date.valid"
                :dateValidationMessage="firstStepErrors.date.errorTooltip"
                :routeType="dateAndType.type"
                :allowWeekends="true"
                data-qa="dateFrom"
                @input="dateAndTypeChanged"
                @close="onDatepickerClose"
              >
                <div style="display:flex; justify-content: space-around">
                  <ob-radio
                    label="Погрузка"
                    valueInput="departure"
                    v-model="type"
                    data-qa="loadingTo"
                  />

                  <ob-radio
                    label="Отгрузка"
                    valueInput="arrive"
                    v-model="type"
                    data-qa="unloadingTo"
                  />
                </div>
              </order-date-picker>
            </div>
          </div>
        </div>
        <div
          class="order-route__row order-route__row--additional"
          v-if="unloadingPoints.length"
        >
          <div
            class="order-route__point"
            v-for="point in unloadingPoints"
            :key="point.uuid"
          >
            <div class="order-route__location-input">
              <div class="order-route__location-input-path">
                <i class="icon route-unloading -green-700" />
                <b> Разгрузка</b>
                <i class="icon close" @click="onRemoveToPoint(point)"></i>
              </div>
              <ObAddressInput
                title="Адрес"
                :address="point.label"
                :isValid="firstStepErrors.address.valid"
                :popoverMessage="firstStepErrors.address.errorTooltip"
                :prefixIcon="point.icon || ''"
                :locationsTypes="locationsTypes"
                placeholder="Например, Невский пр., 1, Санкт-Петербург, Россия"
                required
                :mapId="`map-${point.uuid}`"
                :showMap="false"
                customIcon="map"
                customAction
                data-qa="addressFrom"
                @input="setadditionalUnloading($event, point)"
                @on-change-address="setadditionalUnloading($event, point)"
                @customAction="onOpenMapModal(point, 'to', point)"
              />
              <div class="order-route__base" v-if="point.locationTitle">
                Относится к опорному пункту:
                <span>{{ point.locationTitle }}</span>
              </div>
            </div>
          </div>
        </div>
        <div class="order-route__add">
          <i class="icon plus" />
          <span @click="addUnloadingPoint"> Добавить разгрузку</span>
        </div>
      </div>
    </div>

    <div class="order-step__method">
      <h2 :class="['order-step-title', { active: istransportValid }]">
        Способ перевозки
        <i class="icon checked" />
      </h2>
      <div class="order-methods">
        <ControlGroup
          height="slim"
          tooltipIcon="question"
          :items="[
            {
              label: 'Целые машины',
              value: 'FTL',
            },
            {
              label: 'Контейнеры',
              value: 'CONTAINER',
              tooltipIcon: 'question',
              tooltip: this.role === 'anonymous' ? 'Доступно только авторизованным пользователям': '',
              disabled:
                (this.role === 'client' &&
                  this.formData.bodySaveDraft.contractor.roleCode ===
                    'CARRIER') ||
                this.formData.bodySaveDraft.orderType === 'TMS' || this.formData.bodySaveDraft.orderType === 'ANY' || this.role === 'anonymous'
            },
            {
              label: 'Вагоны',
              value: 'RAIL',
              tooltipIcon: 'question',
              tooltip: this.role === 'anonymous' ? 'Доступно только авторизованным пользователям': '',
              disabled:
                (this.role === 'client' &&
                    this.formData.bodySaveDraft.contractor.roleCode ===
                      'CARRIER') ||
                this.formData.bodySaveDraft.orderType === 'TMS' || this.formData.bodySaveDraft.orderType === 'ANY' || this.role === 'anonymous'
            },
          ]"
          theme="light"
          v-model="activeTransportationWay"
          data-qa="transportationWay"
          @input="changeTransportationWay"
        />
      </div>
      <h3 class="order-step-subtitle">
        {{ $options.transportLabels[activeTransportationWay].label }}
        использовать?
      </h3>
      <div class="order-method-options">
        <div class="order-method-options__services">
          <div class="order-method-options__service">
            <ob-select
              v-model="activeTransport"
              label="Услуга"
              :items="transports"
              placeholder="Выберите из списка"
              position="top"
              :isStandart="true"
              :disabled="transports.length === 1"
              popperClass="transport-type-popper"
              data-qa="transportKind"
              @selected="changeTransport"
            />
          </div>
          <div class="order-method-options__transport">
            <ob-select
              v-model="activeTransportType"
              class="transport-type-select"
              :label="$options.transportLabels[activeTransportationWay].subtype"
              :items="transportTypes"
              placeholder="Выберите из списка"
              position="top"
              :isStandart="false"
              :isValid="firstStepErrors.transportType.valid"
              :popoverMessage="this.firstStepErrors.transportType.errorTooltip"
              :disabled="!transport"
              required
              data-qa="transportType"
              @selected="setTransportType"
            />
          </div>
        </div>
        <div class="order-method-options__qty">
          <ob-stepper
            v-if="contractor.roleCode !== 'CARRIER'"
            v-model="activeTransportQty"
            label="Кол-во"
            :min-value="1"
            :disabled="formData.bodySaveDraft.orderType === 'TMS' || formData.bodySaveDraft.orderType === 'ANY'"
            data-qa="transportQty"
            @input="setTransportQty"
          />
          <obTooltip
            v-else
            content="Возможность заказать несколько ТС будет реализована позднее"
            position="top-start"
          >
            <ob-stepper
              v-model="defaultActiveTransportQty"
              style="pointer-events: auto"
              label="Кол-во"
              :min-value="1"
              data-qa="transportQty"
              :disabled="true"
              @input="setTransportQty"
            />
          </obTooltip>
        </div>
      </div>
      <div class="order-methods">
        <ControlGroup
          tooltipIcon="question"
          :items="[
            {
              label: 'Трекинг груза',
              icon: 'radar',
              value: 'needTracking',
              tooltip:
                'Отслеживание передвижение заказа с помощью специальных приборов - “пломб”, устанавливаемых на транспортные средства',
              disabled: this.formData.bodySaveDraft.orderType !== 'STANDARD'
            },
            {
              label: 'Опасный груз',
              icon: 'hazard',
              value: 'isDangerous',
              tooltip:
                'К опасным грузам относятся любые вещества, материалы, изделия, отходы производственной и иной деятельности, которые в силу присущих им свойств и особенностей могут при их перевозке создавать угрозу для жизни и здоровья людей.',
            },
          ]"
          v-model="activeConditions"
          :multiselect="true"
          theme="light"
          data-qa="conditions"
          @input="onConditionsSelect"
        >
        </ControlGroup>
        <div class="order-temp">
          <ob-select
            v-model="activeTemperatureСondition"
            ref="tempSelect"
            :items="temperatureСonditions"
            :isStandart="true"
            :isAutoComplete="false"
            :disabled="temperatureСonditions.length <= 1"
            placeholder="Выберите из списка"
            displayExp="temperatureModeTitle"
            valueExp="temperatureModeUuid"
            label="Температурный режим"
            data-qa="temperatureSelect"
            @input="onTemperatureSelect"
          >
            <template v-slot="{ items }">
              <div v-if="items" class="temp-list">
                <div class="temp-list__items">
                  <div
                    v-for="item in items.filter(
                      (item) => !item.temperatureModeRootTitle
                    )"
                    :key="item.temperatureModeTitle"
                    class="temp-list__item"
                    @click="selectTemp(item)"
                  >
                    {{ item.temperatureModeTitle }}
                  </div>
                </div>
                <div
                  class="temp-list__items"
                  v-if="
                    items.filter(
                      (item) =>
                        item.temperatureModeRootTitle ===
                        'temperature_mode_root_room_temperature'
                    ).length
                  "
                >
                  <div class="temp-list__title">
                    <i class="icon room-temperature" />
                    Комнатная температура
                  </div>
                  <div
                    v-for="item in items.filter(
                      (item) =>
                        item.temperatureModeRootTitle ===
                        'temperature_mode_root_room_temperature'
                    )"
                    :key="item.temperatureModeTitle"
                    class="temp-list__item"
                    @click="selectTemp(item)"
                  >
                    {{ item.temperatureModeTitle }}
                  </div>
                </div>
                <div
                  class="temp-list__items"
                  v-if="
                    items.filter(
                      (item) =>
                        item.temperatureModeRootTitle ===
                        'temperature_mode_root_cooling'
                    ).length
                  "
                >
                  <div class="temp-list__title">
                    <i class="icon cold" />
                    Охлаждение
                  </div>
                  <div
                    v-for="item in items.filter(
                      (item) =>
                        item.temperatureModeRootTitle ===
                        'temperature_mode_root_cooling'
                    )"
                    :key="item.temperatureModeTitle"
                    class="temp-list__item"
                    @click="selectTemp(item)"
                  >
                    {{ item.temperatureModeTitle }}
                  </div>
                </div>
                <div
                  class="temp-list__items"
                  v-if="
                    items.filter(
                      (item) =>
                        item.temperatureModeRootTitle ===
                        'temperature_mode_root_freezing'
                    ).length
                  "
                >
                  <div class="temp-list__title">
                    <i class="icon freezing" />
                    Заморозка
                  </div>
                  <div
                    v-for="item in items.filter(
                      (item) =>
                        item.temperatureModeRootTitle ===
                        'temperature_mode_root_freezing'
                    )"
                    :key="item.temperatureModeTitle"
                    class="temp-list__item"
                    @click="selectTemp(item)"
                  >
                    {{ item.temperatureModeTitle }}
                  </div>
                </div>
              </div>
            </template>
          </ob-select>
        </div>
      </div>

      <div class="order-step__weight">
        <h2
          :class="{ active: validation.isCargoValid }"
          class="order-step-title"
        >
          Груз
          <i class="icon checked" />
        </h2>
        <div class="input-group">
          <ob-select
            label="Тип груза"
            placeholder="Выберите из списка"
            :items="cargoTypes"
            v-model="form.parameters.cargoTypeUuid"
            displayExp="name"
            required
            data-qa="cargoTypesSelect"
            @input="onCargoTypeChange"
          />
          <div class="order-insurance">
            <ob-input
              v-model.number="form.parameters.insuranceCargo.cost"
              label="Страховая стоимость груза"
              type="money"
              :isTrimOnBlur="false"
              subTitle="₽"
              placeholder="Укажите"
              required
              data-qa="insuranceCargo"
              @input="onInsuranceCostChange"
            />
          </div>
          <!-- <div
            class="order-risk"
            v-if="role === 'clicar' && form.bodySaveDraft.riskColor != null"
          >
            <div class="order-risk__item">
              <p>Группа риска заказа</p>
              <i
                :class="['icon', getRiskClass(form.bodySaveDraft.riskColor)]"
              />
              Группа риска {{ getNumberRisk(form.bodySaveDraft.riskColor) }}
            </div>
            <div class="order-risk__item">
              <p>Подходящие исполнители</p>
              <div class="order-risk__carriers">
                <i
                  v-for="(carrier, index) in carrierColors"
                  :key="carrier"
                  :class="['icon', $options.riskColorsMap[carrier]]"
                  :style="`z-index: ${carrierColors.length - index};`"
                />
              </div>
              Группа риска {{ carrierRisks }}
            </div>
          </div> -->
          <template v-if="errors['CARGO_ERRORS']">
            <div
              class="input-error"
              ref="cargoErrors"
              v-for="error in errors['CARGO_ERRORS']"
              :key="error.code"
            >
              <i class="icon alert" />
              {{ error.description }}
            </div>
          </template>
          <template v-if="errors['CONTRACTOR_ERRORS']">
            <div
              class="input-error"
              v-for="error in errors['CONTRACTOR_ERRORS']"
              :key="error.code"
            >
              <i class="icon alert" />
              {{ error.description }}
            </div>
          </template>
        </div>
      </div>

      <div
        class="order-cargo"
        v-if="
          this.transportationWay === 'CONTAINER' ||
            this.transportationWay === 'RAIL'
        "
      >
        <div class="order-cargo-type">
          <h2
            :class="{ active: validation.isCargoCodeValid }"
            class="order-step-title"
          >
            Код и наименование груза
            <i class="icon checked" />
          </h2>
          <ob-select
            ref="cargoCodesSelect"
            v-model="form.cargo.etsngs"
            :remote-opt="{
              method: getCargoCodes,
            }"
            :details-remote="{
              method: getCargoCode
            }"
            label="ЕТСНГ"
            placeholder="Введите код и наименование груза"
            icon="plus"
            isAutoComplete
            displayExp="denomination"
            valueExp="uuid"
            required
            data-qa="cargoCodesSelect"
            @input="onCargoCodeChanged"
          />
        </div>
        <div class="order-step__weight">
          <h2
            :class="{ active: validation.isCargoWeightValid }"
            class="order-step-title"
          >
            Вес и объём груза
            <i class="icon checked" />
          </h2>
          <div class="input-group">
            <ob-input
              ref="weight"
              v-model.number="form.cargo.weightInKg"
              type="number:strict"
              :isTrimOnBlur="false"
              class="max200 --small"
              placeholder="Укажите вес"
              label="Общий вес груза"
              subTitle="кг"
              required
              data-qa="weightInKg"
              @input="onWeightChanged"
            />
            <ob-input
              v-model.number="form.cargo.volumeInCubicMeters"
              type="number:strict"
              :isTrimOnBlur="false"
              class="max200"
              placeholder="Укажите объём"
              label="Общий объём груза"
              subTitle="м³"
              data-qa="volumeInCubicMeters"
              @input="onCargoChanged('volumeInCubicMeters')"
            />
            <ob-input
              v-model.number="form.cargo.palletCount"
              type="number:strict"
              :isTrimOnBlur="false"
              class="max200"
              placeholder="Укажите кол-во"
              label="Количество паллет"
              subTitle="пл"
              data-qa="palletCount"
              @input="onCargoChanged('palletCount')"
            />
          </div>
        </div>
        <div class="accounting">
          <ob-select
            v-model="form.cargo.freightForwardingUnitUuid"
            label="Единица экспедиторского учёта"
            placeholder="Выберите из списка"
            :items="accountingItems"
            data-qa="freightForwardingUnit"
            @input="onFreightForwardingUnitUuidChanged"
          />
        </div>
      </div>
    </div>

    <AddressMapModal
      ref="mapModal"
      :data-source="{ address: {} }"
      :value="activeAddress"
      :zoom="
        this.activeAddress.icon === 'pin' && this.activeAddress.label.length
          ? 15
          : 8
      "
      :locationsTypes="locationsTypes"
      :direction="activeDirection"
      :additionalPoint="activeAdditionalPoint"
      @input="setAddressFromModal"
      @error="onAddressMapError"
    />
  </div>
</template>

<script>
import api from "@/api";
import { getLocationIconByCode } from '@/helpers';
import { isOutOfVewport } from "@/helpers";
import { mapGetters } from "vuex";
import { getRiskClass } from "@/helpers/risks";
import { getNumberRisk } from "@/helpers/risks";
import { sortRisks } from "@/helpers/risks";
import ObAddressInput from "common-components/src/obComponents/obAddressInput";
import AddressMapModal from "../../pages/logchainPage/components/logchainMapModal";
import obStepper from "common-components/src/obComponents/obStepper";
import obRadio from "common-components/src/obComponents/obRadio";
import obInput from "common-components/src/obComponents/obInput";
import obSelect from "common-components/src/obComponents/obSelect";
import ControlGroup from "common-components/src/obComponents/obControlGroup";
// import orderDatePicker from "../../components/Order/orderDatePicker";
import orderDatePicker from "common-components/src/obComponents/obDatePickerConstructor";
import obTooltip from "common-components/src/obComponents/obTooltip";
// import clicarLogchainCard from "@/components/Order/clicarLogchainCard";

export default {
  props: {
    addressFrom: {
      type: Object,
      required: true,
    },
    addressTo: {
      type: Object,
      required: true,
    },
    transportationWay: {
      type: String,
      default: "FTL",
    },
    locationsTypes: {
      type: Array,
      required: true,
    },
    fromPoints: {
      type: [String, Number],
      required: true,
    },
    toPoints: {
      type: [String, Number],
      default: 1,
    },
    transports: {
      type: Array,
      required: true,
    },
    transport: {
      type: String,
      required: true,
    },
    transportTypes: {
      type: Array,
    },
    transportType: {
      type: String,
    },
    transportQty: {
      type: [String, Number],
    },
    conditions: {
      type: [String, Array],
    },
    temperatureCondition: {
      type: String,
    },
    temperatureСonditions: {
      type: Array,
    },
    isRouteValid: {
      type: Boolean,
      default: false,
    },
    dateFrom: {
      type: [String, Number, Date],
    },
    dateTo: {
      type: [String, Number, Date],
    },
    logchain: {
      type: Object,
      required: true,
    },
    firstStepErrors: {
      type: Object,
      required: true,
    },
    isPrivateContainer: {
      type: Boolean,
      required: true,
    },
    validation: {
      type: Object,
      required: true,
    },
    errors: {
      type: Object,
      default: () => {},
    },
    cargoTypes: {
      type: Array,
      required: true,
    },
    formData: {
      type: Object,
      required: true,
    },
    contractor: {
      type: Object,
      required: true,
    },
    accountingItems: {
      type: Array,
      required: true,
    },
    isSearchingTariff: {
      type: Boolean,
      default: false
    }
  },

  riskColorsMap: {
    GREEN: "risk-1-blue",
    BLUE: "risk-2-green",
    YELLOW: "risk-3-yellow",
    ORANGE: "risk-4-orange",
    RED: "risk-5-red",
    BLACK: "risk-6-black",
  },

  components: {
    ObAddressInput,
    obStepper,
    obRadio,
    obSelect,
    ControlGroup,
    orderDatePicker,
    AddressMapModal,
    obInput,
    obTooltip,
  },

  transportLabels: {
    FTL: {
      label: "Какой автотранспорт",
      type: "Вид автотранспорта",
      subtype: "Тип автотранспорта",
    },
    CONTAINER: {
      label: "Какие контейнеры",
      type: "Вид контейнера",
      subtype: "Тип контейнера",
    },
    RAIL: {
      label: "Какой ЖД транспорт",
      type: "Вид ЖД транспорта",
      subtype: "Тип ЖД транспорта",
    },
  },

  computed: {
    ...mapGetters({
      role: "user/role",
    }),
    loadingPoints() {
      const fromPoint = this.formData.bodySaveDraft.route?.points?.find(
        (item) => item.direction === "FROM"
      );

      return fromPoint.childPoints.map((item) => {
        return {
          uuid: item.params.uuid,
          coordinates: item.params.coordinates,
          icon: item.type === 'ADDRESS' ? 'pin' : item.type === 'REFERENCE_POSITION' ? 'city-sm' : item.type === 'INFRASTRUCTURE_FACILITY' ? item.icon ? item.icon : getLocationIconByCode(item.params.locationTypeCode.toLowerCase()) : 'pin',
          label: item.params.addressTitle,
          isValid: true,
          popoverMessage: "",
          locationTitle: item.locationTitle,
        };
      });
    },
    unloadingPoints() {
      const toPoint = this.formData.bodySaveDraft.route?.points?.find(
        (item) => item.direction === "TO"
      );

      return toPoint.childPoints.map((item) => {
        return {
          uuid: item.params.uuid,
          coordinates: item.params.coordinates,
          icon: item.type === 'ADDRESS' ? 'pin' : item.type === 'REFERENCE_POSITION' ? 'city-sm' : item.type === 'INFRASTRUCTURE_FACILITY' ? item.icon ? item.icon : getLocationIconByCode(item.params.locationTypeCode.toLowerCase()) : 'pin',
          label: item.params.addressTitle,
          isValid: true,
          popoverMessage: "",
          locationTitle: item.locationTitle,
        };
      });
    },
    isMultiStop() {
      return this.loadingPoints?.length > 0 || this.unloadingPoints?.length > 0;
    },
    isContainer() {
      return this.transportationWay === "CONTAINER";
    },
    istransportValid() {
      return this.activeTransportType;
    },
    blockTimeBefore() {
      const date = new Date();
      let h = date.getHours();
      const m = date.getMinutes();
      if (m > 30) {
        h += 1;
      }
      return `${h + 3}:00`;
    },
    disabledStartDates() {
      return [
        {
          from: new Date(1976, 0, 0),
          to: new Date(),
        },
      ];
    },

    dateAndTypeLable() {
      return this.dateAndType.type === "departure"
        ? "Дата и время погрузки"
        : "Дата и время отгрузки";
    },
    carrierRisks() {
      return this.carrierColors
        .map((item) => {
          return this.getNumberRisk(item);
        })
        .join("-");
    },
    carrierColors() {
      return this.formData.bodySaveDraft.acceptedCarrierColors
        ? this.sortRisks({
            data: this.formData.bodySaveDraft.acceptedCarrierColors,
          })
        : [];
    },
  },

  data() {
    return {
      activeDirection: "from",
      activeAddress: {},
      activeIsPrivateContainer: false,
      dateAndType: {
        date: "",
        type: "",
      },
      type: "",
      activeFromPoints: "",
      activeToPoints: "",
      activeTransportationWay: "",
      activeTransport: "",
      activeTransportType: "",
      activeTransportType1: [],
      activeTransportQty: "",
      defaultActiveTransportQty: "1",
      activeConditions: "",
      activeTemperatureCondition: "",
      selectedTemp: "",
      form: "",
      activeAdditionalPoint: null,
    };
  },

  watch: {
    dateFrom: {
      handler: function(newval) {
        if (newval) {
          this.dateAndType.date = newval;
          this.dateAndType.type = "departure";
          this.type = "departure";
        }
      },
      immediate: true,
    },

    formData: {
      handler: function(newVal) {
        this.form = {
          ...newVal
        };
      },
      immediate: true,
      deep: true,
    },

    dateTo: {
      handler: function(newval) {
        if (newval) {
          this.dateAndType.date = newval;
          this.dateAndType.type = "arrive";
          this.type = "arrive";
        }
      },
      immediate: true,
    },

    fromPoints: {
      handler: function(newVal) {
        this.activeFromPoints = newVal;
      },
      immediate: true,
    },
    toPoints: {
      handler: function(newVal) {
        this.activeToPoints = newVal;
      },
      immediate: true,
    },
    transportationWay: {
      handler: function(newVal) {
        this.activeTransportationWay = newVal;
      },
      immediate: true,
    },
    transport: {
      handler: function(newVal) {
        this.activeTransport = newVal;
      },
      immediate: true,
    },
    transportType: {
      handler: function(newVal) {
        this.activeTransportType = newVal;
      },
      immediate: true,
    },
    transportQty: {
      handler: function(newVal) {
        this.activeTransportQty = newVal;
      },
      immediate: true,
    },
    conditions: {
      handler: function(newVal) {
        this.activeConditions = newVal;
      },
      immediate: true,
    },
    temperatureCondition: {
      handler: function(newVal) {
        this.activeTemperatureСondition = newVal;
      },
      immediate: true,
    },
    isPrivateContainer: {
      handler: function(newVal) {
        this.activeIsPrivateContainer = newVal;
      },
      immediate: true,
    },
    errors: {
      handler: function(newVal) {
        if (newVal["CARGO_ERRORS"]?.length) {
          this.$nextTick(() => {
            const el = this.$refs.cargoErrors[0];
            if (isOutOfVewport(el).bottom) {
              el.scrollIntoView({ block: "start", behavior: "smooth" });
            }
          });
        }
      },
      deep: true,
      immediate: true,
    },
  },
  methods: {
    getLocationIconByCode,
    getRiskClass,
    getNumberRisk,
    sortRisks,

    setadditionalLoading($event, point) {
      point.coordinates = $event.coordinates;
      point.icon = $event.icon;
      point.label = $event.label;
      point.locationUuid = $event.locationUuid;
      point.locationTypeUuid = $event.location_type_uuid;
      point.locationTitle = $event.locationTitle;
      this.$emit("setAddresForLoadingPoint", point);
    },

    setadditionalUnloading($event, point) {
      point.coordinates = $event.coordinates;
      point.icon = $event.icon;
      point.label = $event.label;
      point.locationUuid = $event.locationUuid;
      point.locationTypeUuid = $event.location_type_uuid;
      point.locationTitle = $event.locationTitle;
      this.$emit("setAddresForUnloadingPoint", point);
    },

    addLoadingPoint() {
      this.$emit("addLoadingPoint");
    },

    addUnloadingPoint() {
      this.$emit("addUnloadingPoint");
    },

    onRemoveFromPoint(point) {
      this.$emit("removeLoadingPoint", point);
    },

    onRemoveToPoint(point) {
      this.$emit("removeUnloadingPoint", point);
    },

    async getCargoCode() {
      try {
        const extra = await api.orders.getCargoCode({uuids: Array.isArray(this.form.cargo.etsngs) ? [] : [this.form.cargo.etsngs]});
        const temp = extra.values.map(item => {
          return {
            code: item.code,
            denomination: `${item.code} ${item.title}`,
            uuid: item.uuid
          }
        })
        return temp;
      } catch(e) {
          console.error(e);
        }
    },
    async getCargoCodes({ page, size, query }) {
      try {
        const res = await api.orders.getCargoCodes({ page, size, query });
        res.content = res.content.map((item) => {
          return {
            code: item.code,
            denomination: `${item.code} ${item.denomination}`,
            uuid: item.uuid,
          };
        });
        return res;
      } catch (e) {
        console.error(e);
      }
    },

    onWeightChanged() {
      this.$emit("weightChanged", this.form.cargo.weightInKg);
    },
    onCargoChanged(field) {
      this.$emit("cargoChanged", { field, value: this.form.cargo[field] });
    },
    onFreightForwardingUnitUuidChanged() {
      this.$emit(
        "freightForwardingUnitUuidChanged",
        this.form.cargo.freightForwardingUnitUuid
      );
    },
    selectTemp(temp) {
      this.selectedTemp = temp;
      this.$refs.tempSelect.setItem(temp);
    },
    onOpenMapModal(address, direction, point) {
      this.activeAdditionalPoint = point || {};
      this.activeDirection = direction;
      this.activeAddress = {
        ...address,
        icon: address.label.length ? address.icon : "",
      };
      this.$nextTick(() => {
        this.$refs.mapModal.open();
      });
    },
    onAddressMapError() {
      this.$refs.mapModal.close();
      this.$notification({
        type: "system_notification_error",
        message: "Ошибка загрузки карты",
      });
    },
    setAddressFromModal(e) {
      const addr = {
        coordinates: {
          lat: e.payload.coordinates.lat,
          lon: e.payload.coordinates.long,
        },
        isValid: true,
        icon: e.payload.icon,
        label: e.payload.label,
        locationUuid: e.payload.uuid || "",
        locationTitle: e.payload.locationTitle || "",
        countryShortCode: e.payload.countryShortCode || ""
      };
      addr.isValid = true;
      if (e.direction === "from") {
        Object.keys(e.additionalPoint).length
          ? this.setadditionalLoading(addr, e.additionalPoint)
          : this.setAddressFrom(addr);
      } else {
        Object.keys(e.additionalPoint).length
          ? this.setadditionalUnloading(addr, e.additionalPoint)
          : this.setAddressTo(addr);
      }
    },
    onDatepickerClose(e) {
      this.type = e;
    },
    onConditionsSelect() {
      this.$emit("conditionsSelect", this.activeConditions);
    },
    onTemperatureSelect() {
      this.$emit("temperatureSelect", this.selectedTemp);
    },
    changeTransportationWay() {
      this.$emit("transportationWaychanged", this.activeTransportationWay);
    },
    changeTransport() {
      this.$emit("transportChanged", this.activeTransport);
    },

    setTransportType() {
      this.$emit("transportTypeChanged", this.activeTransportType);
    },

    setTransportQty() {
      this.$emit("transportQtyChanged", this.activeTransportQty);
    },

    setAddressFrom($event) {
      this.$emit("addressFromChanged", $event);
    },

    setAddressTo($event) {
      this.$emit("addressToChanged", $event);
    },

    changePoints() {
      this.$emit("needSavePoints", {
        fromPoints: this.activeFromPoints,
        toPoints: this.activeToPoints,
      });
    },

    dateAndTypeChanged() {
      if (!this.dateAndType.date) {
        const date = new Date();
        if (this.type === 'departure') {
          date.setDate(date.getDate() + 1);
        }
        if (this.type === 'arrive') {
          date.setDate(date.getDate() + 7);
        }
        date.setHours(12, 0, 0);
        this.dateAndType.date = this.dateFrom ? this.dateFrom : this.dateTo ? this.dateTo : date;
      }
      this.dateAndType.type = this.type;
      this.$emit("needSaveDate", this.dateAndType);
    },

    isEmptyObj(obj) {
      for (var key in obj) {
        if (obj.hasOwnProperty(key)) {
          return false;
        }
      }
      return true;
    },

    getLength(value) {
      return Math.ceil(value / 1000);
    },

    getDuration(duration) {
      const fm = [
        Math.floor(duration / (3600 * 24)),
        Math.ceil((duration % (3600 * 24)) / 3600),
      ];
      return fm
        .map((v, i) => {
          if (v) {
            if (i === 0) {
              v = this.plural(v, "день | дня | дней");
            } else if (i === 1) {
              v = this.plural(v, "час | часа | часов");
            } else if (i === 2) {
              v = this.plural(v, "минута| минуты | минут");
            } else if (i === 3) {
              v = this.plural(v, "секунда | секунды | секунд");
            }
            return v;
          }
        })
        .join("");
    },

    plural(value, unit) {
      return value + this.declOfNum(value, unit);
    },

    declOfNum(n, string) {
      let titles = string.split("|");
      return titles[
        n % 10 == 1 && n % 100 != 11
          ? 0
          : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20)
          ? 1
          : 2
      ];
    },

    onCargoTypeChange() {
      this.$emit("cargoTypeChanged", this.form.parameters.cargoTypeUuid);
    },

    onInsuranceCostChange() {
      this.$emit(
        "insuranceCostChanged",
        this.form.parameters.insuranceCargo.cost
      );
    },

    onCargoCodeChanged() {
      this.$emit("cargoCodeChanged", this.form.cargo.etsngs);
    },

    onCommentsChanged() {
      this.$emit("commentsChanged", this.form.parameters.comments);
    },

    saveComment() {
      this.$emit("commentsChanged", this.form.parameters.comments);
    },
  },

  directives: {
    int: {
      bind: function(el, binding, vnode) {
        const _this = vnode.context;
        el.addEventListener("keydown", (e) => {
          if (
            [46, 8, 9, 27, 13].indexOf(e.keyCode) !== -1 ||
            // Allow: Ctrl+A
            (e.keyCode === 65 && e.ctrlKey === true) ||
            // Allow: Ctrl+C
            (e.keyCode === 67 && e.ctrlKey === true) ||
            // Allow: Ctrl+X
            (e.keyCode === 88 && e.ctrlKey === true) ||
            // Allow: home, end, left, right
            (e.keyCode >= 35 && e.keyCode <= 39)
          ) {
            return;
          }

          const val = _this.$refs.weight.value + "";
          if (val.length >= 4) {
            e.preventDefault();
          }
          const findDot = new RegExp(/\./g);
          const containsDot = val.match(findDot);
          if (val && containsDot) {
            const dec = val.split(".");
            if (dec[1].length >= 1) {
              e.preventDefault();
            }
          }
        });
      },
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.icon {
  &.route-loading {
    color: #ffb137;
  }
  &.route-unloading {
    color: #00cca6;
  }
}

.order-step__route-header {
  display: flex;
  align-items: center;
}

.order-route__row {
  margin: 10px 0;

  &--additional {
    display: block;
    margin-top: 20px;

    .order-route__location-input-path {
      display: flex;
      align-items: center;

      i:first-of-type {
        margin-right: 5px;
      }

      i:last-of-type {
        margin-left: auto;
        color: $color-grey-span;
        cursor: pointer;
      }
    }
  }
}

.order-route__row + .order-route__row {
  margin-top: 40px;
}

.order-route__row-content {
  display: flex;
}

.order-route__base {
  margin-top: 6px;
  @include font-mixin(12px, 12px, 400, $gray-slate);

  span {
    @include font-mixin(12px, 12px, 400, $color-text-base);
  }
}

.order-route__point {
  margin-right: -19px;
  padding: 10px 20px;

  &:hover {
    background-color: $color-white-lilac;
  }
}

.order-route__point + .order-route__point {
  margin-top: 10px;
}

.order-route__add {
  display: inline-block;
  vertical-align: middle;
  font-size: 14px;
  line-height: 16px;
  letter-spacing: 0.2px;
  color: $color-blue-navy-blue;
  padding: 10px 0 18px 20px;

  span {
    cursor: pointer;
  }
}

.order-step__route-info {
  margin: 0 0 5px 30px;
  @include font-mixin(12px, 16px, 400, $color-blue-navy-blue);

  span {
    margin-right: 20px;
    color: $gray-slate;
  }
}

.order-step-subtitle {
  margin: 0 0 15px;
  font-weight: bold;
  font-size: 16px;
}

.order-route__location {
  width: 79%;
  min-width: 250px;
  display: flex;
  align-items: flex-end;

  @media screen and (min-width: 1450px) {
    width: 750px;
  }
}

.order-route__location-input {
  flex-grow: 1;
  &-path {
    font-size: 16px;
    line-height: 20px;
    letter-spacing: 0.4px;
    padding-bottom: 10px;
  }
}

.order-route__points {
  width: 30%;
  max-width: 160px;
  margin-left: 10px;

  @media screen and (min-width: 1450px) {
    width: 160px;
  }
}

.order-route__date {
  margin-left: 10px;
  z-index: 1;
  height: 52px;
  position: relative;
  width: 21%;

  @media screen and (min-width: 1450px) {
    width: 210px;
  }
}

.order-step__method {
  margin-top: 22px;
}

.order-methods {
  margin-bottom: 30px;
  display: flex;
  max-width: 750px;
}

.order-method-options {
  display: flex;
  margin-bottom: 30px;
  margin-top: 20px;

  &__services {
    margin-right: 10px;
    width: 79%;
    display: flex;
    min-width: 250px;

    @media screen and (min-width: 1450px) {
      width: 750px;
    }
  }

  &__service {
    margin-right: 10px;
  }

  &__transport {
    flex-grow: 1;
  }

  &__qty {
    width: 21%;

    @media screen and (min-width: 1450px) {
      width: 210px;
    }
  }
}

.transport-type-select {
  min-width: 400px;
}

.order-temp {
  margin-left: 10px;
  flex-grow: 1;
  max-width: 334px;
}

::v-deep {
  .ob-selector__select {
    min-height: auto;
    height: 50px;
  }
}

.temp-list {
  @include font-mixin(15px, 16px, 400, $color-text-base);

  span {
    display: block;
    padding: 12px 22px;
    cursor: pointer;
  }
}

.temp-list {
  padding: 20px 0;
}

.temp-list__item {
  padding: 5px 22px 5px 20px;
  cursor: pointer;

  &:hover {
    background-color: $light-lavender;
  }
}

.temp-list__title {
  display: flex;
  align-items: center;
  padding: 11px 20px 4px 20px;
  font-weight: 700;

  i {
    margin-right: 5px;
    font-size: 20px;
    color: $color-blue-smalt;
  }
}

.input-group {
  display: flex;
  margin-bottom: 24px;
  flex-wrap: wrap;

  .ob-selector {
    margin-bottom: 0;
  }

  div:first-child:not(.--small) {
    flex-grow: 1;
    max-width: 750px;
  }

  & > * {
    margin-right: 10px;
  }
}

.order-step__weight {
  margin-top: 29px;

  .order-step-title {
    margin: 0 0 18px;
  }
}

.accounting {
  display: flex;

  .ob-selector {
    margin-right: 22px;
    max-width: 390px;
  }
}

.order-step__type {
  margin-top: 40px;

  .ob-selector {
    max-width: 653px;
  }
}

.order-insurance {
  margin-right: 0;
}

.order-insurance__risk {
  margin-left: 10px;
  display: flex;
  align-items: center;

  .icon {
    font-size: 20px;
    margin-right: 7px;
    color: $components-orderSecondScreen_order_insurance_risk_icon;
  }
}

.order-risk {
  margin-top: 20px;
  width: 100%;
  display: flex;
  align-items: center;
  font-size: 12px;
  line-height: 12px;
  letter-spacing: 0.4px;
  color: $color-text-base;

  .icon {
    font-size: 18px;
    margin-right: 3px;
  }
}

.order-risk__item {
  flex-grow: 0 !important;
  display: flex;
  align-items: center;
  flex-wrap: wrap;

  p {
    width: 100%;
    margin-bottom: 7px;
    color: $gray-slate;
  }
}

.order-risk__carriers {
  display: flex;
  // flex-direction: row-reverse;

  .icon {
    position: relative;
    margin-right: 0;

    &:not(:first-child) {
      margin-left: -10px;
    }
  }
}

.input-error {
  padding: 19px 20px 12px;
  margin-top: 20px;
  width: 100%;
  display: flex;
  align-items: center;
  background-color: rgba($color-error, 0.1);
  @include font-mixin(14px, 20px, 400, $color-text-base);

  .icon {
    margin-right: 20px;
    position: relative;
    top: 2px;
    font-size: 24px;
    color: $color-error;
  }
}

.order-cargo {
  padding-bottom: 15px;
}
</style>
<style>
  .transport-type-popper {
    width: 300px !important;
  }
</style>
